%define bootstrap 0
%{?_without_bootstrap: %global bootstrap 0}
%{?_with_bootstrap: %global bootstrap 1}

# disable by default, mozjs185 symbols conflict with firefox and make it crash (#6299)
# see also https://bugzilla.novell.com/show_bug.cgi?id=759123
#          https://bugzilla.mozilla.org/show_bug.cgi?id=763185
%bcond_with mozjs

%define major 1
%define libname		%mklibname proxy %{major}
%define develname	%mklibname -d proxy
%define gnomename	%mklibname proxy-gnome
%define kdename		%mklibname proxy-kde
%define nmname		%mklibname proxy-networkmanager
%define mozjsname	%mklibname proxy-mozjs
%define webkitname	%mklibname proxy-webkit
%define first_biarch_version	0.4.7-2
%define _libexecdir	%{_prefix}/lib

Name:           libproxy
Version:        0.4.11
Release:        %mkrel 3
Summary:        A library handling all the details of proxy configuration

Group:          System/Libraries
License:        LGPLv2+
URL:            http://code.google.com/p/libproxy/
# http://code.google.com/p/libproxy/issues/detail?id=130&can=1&q=perl
Source0:        http://%{name}.googlecode.com/files/%{name}-%{version}.tar.gz
# (cjw) fix perl binding build: add -lpthread
Patch2:		libproxy-0.4.7-pthread.patch

BuildRequires:  cmake
BuildRequires:  python-devel
#perl
BuildRequires:  perl-devel
%if !%{bootstrap}
%if %{with mozjs}
# mozjs
BuildRequires:  pkgconfig(mozjs185)
%endif
# NetworkManager
BuildRequires:  NetworkManager-devel
BuildRequires:  dbus-glib-devel
# gnome3
BuildRequires:	glib2-devel >= 2.26
# webkit (gtk)
BuildRequires:  webkitgtk3-devel
# kde
BuildRequires:	kdelibs4-devel
BuildRequires:  libxmu-devel
%endif


%description
libproxy offers the following features:

    * extremely small core footprint (< 35K)
    * no external dependencies within libproxy core
      (libproxy plugins may have dependencies)
    * only 3 functions in the stable external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment 

%package -n %{libname}
Group:System/Libraries
Summary:        A library handling all the details of proxy configuration
#Virtual Provides - We need either mozjs or WebKit
%if !%{bootstrap}
Requires: %{name}-pac >= %{version}
%endif
Obsoletes:	libproxy0
%if !%{with mozjs}
Obsoletes:     %{mklibname proxy-mozjs} < %version-%release
%endif

%description -n %{libname}
libproxy offers the following features:

    * extremely small core footprint (< 35K)
    * no external dependencies within libproxy core
      (libproxy plugins may have dependencies)
    * only 3 functions in the stable external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment 

%package        utils
Summary:        Binary to test %{name}
Group:          System/Networking
Requires:       %{libname} = %{version}-%{release}

%description    utils
The %{name}-utils package contains the proxy binary for %{name}

%package -n python-%{name}
Summary:        Binding for %{name} and python
Group:          Development/Python
Requires:       %{libname} = %{version}-%{release}

%description -n python-%{name}
The python-%{name} package contains the python binding for %{name}

%package        perl
Summary:        Perl bindings for %{name}
Group:          Development/Perl
Requires:       %{libname} = %{version}-%{release}

%description    perl
This contains the perl bindings for the libproxy library.

%package	gxsettings
Summary:	Helper utility for %{name} gnome support
Group:		System/Libraries

%description gxsettings
A helper utility for %{name} gnome support.

%package -n     %{gnomename}
Summary:        Plugin for %{name} and gnome
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}
%if !%{bootstrap}
Requires:       %{nmname} = %{version}-%{release}
%endif
Requires:	%{name}-gxsettings = %{version}-%{release}
Obsoletes:	libproxy-gnome < %{first_biarch_version}
Requires:	gsettings-desktop-schemas

%description -n %{gnomename}
The %{name}-gnome package contains the %{name} plugin for gnome.

%if !%{bootstrap}
%package -n     %{kdename}
Summary:        Plugin for %{name} and kde
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}
Requires:       %{nmname} = %{version}-%{release}
Obsoletes:	libproxy-kde < %{first_biarch_version}

%description -n %{kdename}
The %{name}-kde package contains the %{name} plugin for kde.

%package -n     %{nmname}
Summary:        Plugin for %{name} and NetworkManager
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}

%description -n %{nmname}
The %{name}-networkmanager package contains the %{name} plugin for NetworkManager.

%package -n     %{mozjsname}
Summary:        Plugin for %{name} and mozjs
Group:          System/Libraries
Requires:       %{libname} = %{version}
Provides:       %{name}-pac = %{version}-%{release}
Obsoletes:	libproxy-mozjs < %{first_biarch_version}

%description -n %{mozjsname}
The %{name}-mozjs package contains the %{name} plugin for mozjs.

%package -n     %{webkitname}
Summary:        Plugin for %{name} and webkit
Group:          System/Libraries
Requires:       %{libname} = %{version}
Provides:       %{name}-pac = %{version}-%{release}
Obsoletes:	libgnome-webkit < %{first_biarch_version}

%description -n %{webkitname}
The %{name}-webkit package contains the %{name} plugin for
webkit.
%endif

%package -n %{develname}
Summary:        Development files for %{name}
Group:          Development/C
Requires:       %{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{develname}
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q
%apply_patches

%build
%if %{bootstrap}
export CC="gcc -L$(pkg-config --variable sdkdir libxul)/lib"
%endif
# (blino) do not build pacrunner as internal (BIPR=OFF), to avoid having gtk deps in the main package
%cmake -Dlibexecdir=%{_libexecdir} -DLIBEXEC_INSTALL_DIR=%{_libexecdir} \
-DMODULE_INSTALL_DIR=%{_libdir}/%{name}/%{version}/modules \
-DBIPR=OFF \
%if !%{with mozjs}
-DWITH_MOZJS=OFF \
%endif
-DPERL_VENDORINSTALL=1 -DWITH_WEBKIT3=1
%make

%install
rm -rf %{buildroot}
cd build
%makeinstall_std
#gw fix pkgconfig file
sed -i -e "s^Version:.*^Version: %version^" %{buildroot}%{_libdir}/pkgconfig/*.pc

%clean
rm -rf %{buildroot}

%files -n %{libname}
%doc AUTHORS README
%{_libdir}/libproxy.so.%{major}*
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/%{version}
%dir %{_libdir}/%{name}/%{version}/modules

%files utils
%{_bindir}/proxy

%files -n python-%{name}
%{py_sitedir}/*

%files perl
%{perl_vendorarch}/Net/Libproxy.pm
%{perl_vendorarch}/auto/Net/Libproxy

%files gxsettings
%{_libexecdir}/pxgsettings
#{_prefix}/libexec/pxgsettings

%files -n %{gnomename}
%{_libdir}/%{name}/%{version}/modules/config_gnome3.so

%if !%{bootstrap}
%files -n %{kdename}
%{_libdir}/%{name}/%{version}/modules/config_kde4.so

%files -n %{nmname}
%{_libdir}/%{name}/%{version}/modules/network_networkmanager.so

%if %{with mozjs}
%files -n %{mozjsname}
%{_libdir}/%{name}/%{version}/modules/pacrunner_mozjs.so
%endif

%files -n %{webkitname}
%{_libdir}/%{name}/%{version}/modules/pacrunner_webkit.so
%endif

%files -n %{develname}
%{_includedir}/proxy.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/libproxy-1.0.pc
%{_datadir}/cmake/Modules/Findlibproxy.cmake


%changelog

* Tue Jan 22 2013 fwang <fwang> 0.4.11-3.mga3
+ Revision: 390902
- update rpm group

* Sat Jan 12 2013 umeabot <umeabot> 0.4.11-2.mga3
+ Revision: 358008
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 25 2012 luigiwalser <luigiwalser> 0.4.11-1.mga3
+ Revision: 334840
- 0.4.11

* Fri Oct 19 2012 blino <blino> 0.4.10-1.mga3
+ Revision: 308355
- drop custom patch and use new BIPR option to disable building pac runner as internal
- 0.4.10
- drop merged patches

* Thu Oct 11 2012 ovitters <ovitters> 0.4.7-10.mga3
+ Revision: 304660
- add require on gsettings-desktop-schemas (mga#7766)

* Sat Sep 08 2012 blino <blino> 0.4.7-9.mga3
+ Revision: 290383
- move obsoletes to the library package (main package is not created since it does not have any files)

* Sat Sep 08 2012 blino <blino> 0.4.7-8.mga3
+ Revision: 290347
- obsolete mozjs sub-module when disabled to automatically fix #6299 on upgrades
- fix build with gcc 4.7 (upstream r833)
- force js engine sub-module creation even if only one is enabled
- use apply_patches macro
- disable mozjs build by default, mozjs185 symbols conflict with firefox and make it crash (#6299)

* Wed May 30 2012 jquelin <jquelin> 0.4.7-7.mga3
+ Revision: 250907
- perl 5.16 rebuild

* Tue Apr 17 2012 blino <blino> 0.4.7-6.mga2
+ Revision: 231177
- require NetworkManager detection module in Gnome and KDE packages
  (it only pulls dbus as a dependency)
- add networkmanager subpackage
- add back libproxy-mozjs and libproxy-webkit packages
- mozjs: fix resolving local hostname (from upstream)
- enable networkmanager module
- enable again mozjs support using mozjs185 (patch from upstream)

* Sun Feb 19 2012 tv <tv> 0.4.7-5.mga2
+ Revision: 210753
- fix obsoletes on x86_64

* Sat Feb 18 2012 tv <tv> 0.4.7-4.mga2
+ Revision: 210510
- drop libproxy-webkit
- drop libproxy-mozjs
- do not try to build with libxulrunner
- rebuild for new xulrunner

* Sat Sep 17 2011 fwang <fwang> 0.4.7-3.mga2
+ Revision: 144519
- correct build with webkit 1.5

* Wed Jun 22 2011 cjw <cjw> 0.4.7-2.mga2
+ Revision: 112515
- allow biarch installation of modules
- put the gnome3 config helper app in /usr/lib in a separate package

* Tue Jun 21 2011 cjw <cjw> 0.4.7-1.mga2
+ Revision: 111504
- 0.4.7
- drop gnome2 module
- add gnome3 module
- drop libmodman package: it is now built into libproxy and nothing else used it
- build webkit module against webkitgtk3

* Sat Jun 11 2011 sander85 <sander85> 0.4.6-9.mga2
+ Revision: 103956
- perl 5.14

* Sun May 15 2011 pterjan <pterjan> 0.4.6-8.mga1
+ Revision: 98944
- Rebuild for fixed find-requires

* Wed Apr 20 2011 pterjan <pterjan> 0.4.6-7.mga1
+ Revision: 89143
- Use upstream fix for firefox 4

  + ennael <ennael>
    - obsoletes libproxy0 (upgrade from mdv)

* Sat Jan 22 2011 pterjan <pterjan> 0.4.6-5.mga1
+ Revision: 33136
- Fix build with firefox 4
- Disbale bootstrap

  + jquelin <jquelin>
    - rebuild

* Sat Jan 15 2011 blino <blino> 0.4.6-3.mga1
+ Revision: 18885
- bootstrap libproxy
- do not build xulrunner and kde plugins in bootstrap
- imported package libproxy

